Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6501)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6533)
@@ -54,5 +54,14 @@
          <field id="mldr10_1max"  long_name="Max of Mixed Layer Depth (dsigma = 0.01 wrt 10m)"   field_ref="mldr10_1"   operation="maximum"                                                                          />
          <field id="mldr10_1min"  long_name="Min of Mixed Layer Depth (dsigma = 0.01 wrt 10m)"   field_ref="mldr10_1"   operation="minimum"                                                                          />
-         <field id="mldzint"      long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness_defined_by_sigma_theta"                                unit="m"          />
+         <field id="mldzint_1"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_2"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_3"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_4"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_5"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldhtc_1"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_2"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_3"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_4"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_5"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
          <field id="heatc"        long_name="Heat content vertically integrated"                 standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
          <field id="saltc"        long_name="Salt content vertically integrated"                                                                                                                   unit="1e-3*kg/m2" />
Index: branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 6501)
+++ branches/UKMO/dev_r5518_GO6_package/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 6533)
@@ -883,11 +883,12 @@
 !!             Tracers & Dynamics vertical physics namelists
 !!======================================================================
-!!    namzdf            vertical physics
-!!    namzdf_ric        richardson number dependent vertical mixing     ("key_zdfric")
-!!    namzdf_tke        TKE dependent vertical mixing                   ("key_zdftke")
-!!    namzdf_kpp        KPP dependent vertical mixing                   ("key_zdfkpp")
-!!    namzdf_ddm        double diffusive mixing parameterization        ("key_zdfddm")
-!!    namzdf_tmx        tidal mixing parameterization                   ("key_zdftmx")
+!!    namzdf        vertical physics
+!!    namzdf_ric    richardson number dependent vertical mixing         ("key_zdfric")
+!!    namzdf_tke    TKE dependent vertical mixing                       ("key_zdftke")
+!!    namzdf_kpp    KPP dependent vertical mixing                       ("key_zdfkpp")
+!!    namzdf_ddm    double diffusive mixing parameterization            ("key_zdfddm")
+!!    namzdf_tmx    tidal mixing parameterization                       ("key_zdftmx")
 !!    namzdf_tmx_new    new tidal mixing parameterization               ("key_zdftmx_new")
+!!    namzdf_mldzint vertically-interpolated mixed-layer depth parameters
 !!======================================================================
 !
@@ -1003,4 +1004,18 @@
    ln_tsdiff   = .true.    !  account for differential T/S mixing (T) or not (F)
 /
+!------------------------------------------------------------------------------------------
+&namzdf_mldzint    !   Parameters for vertically-interpolated mixed-layer depth diagnostic
+!------------------------------------------------------------------------------------------
+   nn_mld_diag = 0         !  Number of MLD diagnostics to use from below
+
+!              ! MLD criterion ! Reference ! Finite difference ! Gradient layer !
+!              ! type          ! depth     ! criterion         ! criterion      !
+   sn_mld1     =       1       ,    10.0   ,        0.2        ,       0.1
+   sn_mld2     =       ''      ,      ''   ,         ''        ,        ''
+   sn_mld3     =       ''      ,      ''   ,         ''        ,        ''
+   sn_mld4     =       ''      ,      ''   ,         ''        ,        ''
+   sn_mld5     =       ''      ,      ''   ,         ''        ,        ''
+/
+
 !!======================================================================
 !!                  ***  Miscellaneous namelists  ***